<?php

class GDPTDB {
    function render_meta_robots($name, $value, $extra = "") {
?>
        <select name="<?php echo $name; ?>"<?php echo $extra; ?>>
            <option value=""><?php _e("None", "gd-press-tools"); ?></option>
            <option value="index,follow"<?php echo $value == "index,follow" ? ' selected="selected"' : ''; ?>><?php _e("Index, Follow", "gd-press-tools"); ?></option>
            <option value="index,nofollow"<?php echo $value == "index,nofollow" ? ' selected="selected"' : ''; ?>><?php _e("Index, No follow", "gd-press-tools"); ?></option>
            <option value="noindex,follow"<?php echo $value == "noindex,follow" ? ' selected="selected"' : ''; ?>><?php _e("No index, Follow", "gd-press-tools"); ?></option>
            <option value="noindex,nofollow"<?php echo $value == "noindex,nofollow" ? ' selected="selected"' : ''; ?>><?php _e("No index, No follow", "gd-press-tools"); ?></option>
        </select>
<?php
    }

    function get_php_gd_version() {
        $gdi = gd_info();
        return $gdi["GD Version"];
    }

    function insert_posts_views($post_id, $user = true) {
        global $wpdb, $table_prefix;
        $day = date("Y-m-d");
        $sql = sprintf("update %sgdpt_posts_views set %s_views = %s_views + 1 where post_id = %s and day = '%s'",
            $table_prefix, $user ? "usr" : "vst", $user ? "usr" : "vst", $post_id, $day);
        $wpdb->query($sql);
        if ($wpdb->rows_affected == 0) {
            $sql = sprintf("insert into %sgdpt_posts_views (post_id, day, %s_views) values (%s, '%s', 1)",
                $table_prefix, $user ? "usr" : "vst", $post_id, $day);
            $wpdb->query($sql);
        }
    }

    function insert_users_tracking($post_id, $user_id) {
        global $wpdb, $table_prefix;
        $day = date("Y-m-d");
        $sql = sprintf("update %sgdpt_users_tracking set views = views + 1 where user_id = %s and post_id = %s and day = '%s'",
            $table_prefix, $user_id, $post_id, $day);
        $wpdb->query($sql);
        if ($wpdb->rows_affected == 0) {
            $sql = sprintf("insert into %sgdpt_users_tracking (user_id, post_id, day, views) values (%s, %s, '%s', 1)",
                $table_prefix, $user_id, $post_id, $day);
            $wpdb->query($sql);
        }
    }

    function set_posts_comments_status($date, $comments = 0, $pings = 0) {
        global $wpdb, $table_prefix;
        $set = array();
        if ($comments == 1) $set[] = "comment_status = 'closed'";
        if ($pings == 1) $set[] = "ping_status = 'closed'";
        if ($date != "" && count($set) > 0) {
            $sql = sprintf("update %sposts %s where post_date < '%s'", $table_prefix, join(", ", $set), $date);
            $wpdb->query($sql);
        }
    }

    function get_posts_for_delete($post_date) {
        global $wpdb, $table_prefix;
        $sql = sprintf("select id from %sposts where post_type = 'post' and post_status = 'publish' and post_date < '%s'", $table_prefix, $post_date);
        wp_gdpt_log_sql("DELETE_POSTS_GET_IDS", $sql);
        $ids_raw = $wpdb->get_results($sql);
        $ids = array();
        foreach ($ids_raw as $id) $ids[] = $id->id;
        return $ids;
    }

    function delete_posts($post_date) {
        global $wpdb, $table_prefix;
        $ids = GDPTDB::get_posts_for_delete($post_date);
        $results["posts"] = count($ids);
        $ids = join(",", $ids);
        $sql = sprintf("delete from %scomments where comment_post_id in (%s)", $table_prefix, $ids);
        wp_gdpt_log_sql("DELETE_POSTS_COMMENTS", $sql);
        $wpdb->query($sql);
        $results["comments"] = $wpdb->rows_affected;
        $sql = sprintf("delete %s, %s, %s from %sposts p left join %sterm_relationships t on t.object_id = p.ID left join %spostmeta m on m.post_id = p.ID where p.ID in (%s)",
            gdFunctionsGDPT::mysql_pre_4_1() ? sprintf("%sposts", $table_prefix) : "p",
            gdFunctionsGDPT::mysql_pre_4_1() ? sprintf("%sterm_relationships", $table_prefix) : "t",
            gdFunctionsGDPT::mysql_pre_4_1() ? sprintf("%spostmeta", $table_prefix) : "m",
            $table_prefix, $table_prefix, $table_prefix, $ids);
        wp_gdpt_log_sql("DELETE_POSTS_POSTS", $sql);
        $wpdb->query($sql);
        $sql = sprintf("delete %s, %s, %s from %sposts p left join %sterm_relationships t on t.object_id = p.ID left join %spostmeta m on m.post_id = p.ID where p.post_type = 'revision' and p.post_parent in (%s)",
            gdFunctionsGDPT::mysql_pre_4_1() ? sprintf("%sposts", $table_prefix) : "p",
            gdFunctionsGDPT::mysql_pre_4_1() ? sprintf("%sterm_relationships", $table_prefix) : "t",
            gdFunctionsGDPT::mysql_pre_4_1() ? sprintf("%spostmeta", $table_prefix) : "m",
            $table_prefix, $table_prefix, $table_prefix, $ids);
        wp_gdpt_log_sql("DELETE_POSTS_REST", $sql);
        $wpdb->query($sql);
        return $results;
    }

    function get_mysql_server_info() {
        global $wpdb, $table_prefix;
        return $wpdb->get_results("SHOW VARIABLES");
    }

    function rename_account($new_username) {
        global $userdata, $wpdb, $table_prefix;
        $old_username = $userdata->user_login;
        $user_id = $userdata->ID;
        $new_username = apply_filters('pre_user_login', $new_username);
        if (!validate_username($new_username)) return __("Username is invalid.", "gd-press-tools");
        if (strcasecmp($old_username, $new_username) == 0) return __("Username is the same. Nothing is changed.", "gd-press-tools");
        if (username_exists($new_username) != null) return __("Choosen username already exists.", "gd-press-tools");

        $user_nicename = sanitize_title($new_username);
	$user_nicename = apply_filters('pre_user_nicename', $user_nicename);

        $sql = sprintf("update %susers set user_login = '%s', user_nicename = '%s' where ID = %s", $table_prefix, $new_username, $user_nicename, $user_id);
        $wpdb->query($sql);
        $sql = sprintf("update %scomments set comment_author = '%s' where comment_author = '%s' and user_id = %s", $table_prefix, $new_username, $old_username, $user_id);
        $wpdb->query($sql);
        return "OK";
    }

    function get_tables_status() {
        global $wpdb, $table_prefix;
        $sql = "SHOW TABLE STATUS LIKE '".str_replace("_", "\_", $table_prefix)."%'";
        return $wpdb->get_results($sql);
    }

    function get_tables_size() {
        $tables = GDPTDB::get_tables_status();
        $size = 0;
        foreach ($tables as $t) {
            $size += $t->Data_length;
        }
        return gdFunctionsGDPT::size_format($size);
    }

    function get_database_size() {
        global $wpdb;
        $tables = $wpdb->get_results("SHOW TABLE STATUS");
        $size = 0;
        foreach ($tables as $t) {
            $size += $t->Data_length;
        }
        return gdFunctionsGDPT::size_format($size);
    }

    function get_tables_overhead() {
        $tables = GDPTDB::get_tables_status();
        $size = 0;
        foreach ($tables as $t) {
            $size += $t->Data_free;
        }
        return gdFunctionsGDPT::size_format($size);
    }

    function check_table($table) {
        global $wpdb, $table_prefix;
        $sql = "CHECK TABLE ".$table;
        return $wpdb->get_row($sql);
    }
}

?>
